diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMeshGold.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMeshGold.java
index 537004ec9..f741b9fad 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMeshGold.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMeshGold.java
@@ -8,7 +8,7 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -19,7 +19,7 @@ public class BlockLogicMeshGold extends BlockLogicMesh {
     }
 
     @Override
-    public boolean onInteracted(@NotNull World world, @NotNull TilePos tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
+    public boolean onInteracted(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
         if (world.getTileEntity(tilePos) instanceof TileEntityMeshGold meshGold) {
             ItemStack heldItem = player.getHeldItem();
             boolean flag = meshGold.setFilterItem(player, heldItem);
@@ -33,7 +33,7 @@ public class BlockLogicMeshGold extends BlockLogicMesh {
     }
 
     @Override
-    public boolean collidesWithEntity(@NotNull Entity entity, @NotNull World world, @NotNull TilePos tilePos) {
+    public boolean collidesWithEntity(@NotNull Entity entity, @NotNull World world, @NotNull TilePosc tilePos) {
         if (entity instanceof EntityItem entityItem && world.getTileEntity(tilePos) instanceof TileEntityMeshGold meshGold){
             if (meshGold.filterItem == null) return true;
 
@@ -44,7 +44,7 @@ public class BlockLogicMeshGold extends BlockLogicMesh {
     }
 
     @Override
-    public boolean isEquivalent(@NotNull World world, @NotNull TilePos thisPos, @NotNull TilePos thatPos) {
+    public boolean isEquivalent(@NotNull World world, @NotNull TilePosc thisPos, @NotNull TilePosc thatPos) {
         if (super.isEquivalent(world, thisPos, thatPos)) {
             TileEntity thisEntity = world.getTileEntity(thisPos);
             TileEntity otherEntity = world.getTileEntity(thatPos);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMobSpawner.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMobSpawner.java
index 4a1bf452a..106c46fd3 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMobSpawner.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMobSpawner.java
@@ -10,20 +10,19 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.gamemode.Gamemode;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-public class BlockLogicMobSpawner extends BlockLogicMobSpawnerDeactivated
-{
+public class BlockLogicMobSpawner extends BlockLogicMobSpawnerDeactivated {
 
-	public BlockLogicMobSpawner(@NotNull Block<?> block) {
+    public BlockLogicMobSpawner(@NotNull Block<?> block) {
         super(block);
         block.withEntity(TileEntityMobSpawner::new);
     }
 
     @Override
-    public boolean onInteracted(@NotNull World world, @NotNull TilePos tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
+    public boolean onInteracted(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
         if (player.getGamemode() != Gamemode.creative) {
             return false;
         }
@@ -33,14 +32,14 @@ public class BlockLogicMobSpawner extends BlockLogicMobSpawnerDeactivated
     }
 
     @Override
-    public void onPlacedOnSide(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side, double xHit, double yHit) {
+    public void onPlacedOnSide(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
         if (world.getTileEntity(tilePos) instanceof TileEntityMobSpawner spawner) {
             spawner.setMobId("none");
         }
     }
 
     @Override
-    public void onRemoved(@NotNull World world, @NotNull TilePos tilePos, int data) {
+    public void onRemoved(@NotNull World world, @NotNull TilePosc tilePos, int data) {
         if (!world.isClientSide) {
             TileEntityMobSpawner tileEntityMobSpawner = (TileEntityMobSpawner) world.getTileEntity(tilePos);
             if (tileEntityMobSpawner == null) return;
@@ -48,16 +47,17 @@ public class BlockLogicMobSpawner extends BlockLogicMobSpawnerDeactivated
             label0:
             for (int l = 0; l < amountToDrop; l++) {
                 String mobInSpawner = tileEntityMobSpawner.getMobId();
-                if(mobInSpawner != null) {
+                if (mobInSpawner != null) {
                     ItemStack itemstack =
-                    switch (mobInSpawner) {
-                        case "minecraft:zombie" -> new ItemStack(Items.CLOTH);
-                        case "minecraft:skeleton" -> world.rand.nextInt(2) == 0 ? new ItemStack(Items.BONE) : new ItemStack(Items.AMMO_ARROW);
-                        case "minecraft:zombie_armored" -> new ItemStack(Items.CHAINLINK);
-                        case "minecraft:spider" -> new ItemStack(Items.STRING);
-                        case "minecraft:snowman" -> new ItemStack(Items.AMMO_SNOWBALL);
-                        default -> null;
-                    };
+                        switch (mobInSpawner) {
+                            case "minecraft:zombie" -> new ItemStack(Items.CLOTH);
+                            case "minecraft:skeleton" ->
+                                world.rand.nextInt(2) == 0 ? new ItemStack(Items.BONE) : new ItemStack(Items.AMMO_ARROW);
+                            case "minecraft:zombie_armored" -> new ItemStack(Items.CHAINLINK);
+                            case "minecraft:spider" -> new ItemStack(Items.STRING);
+                            case "minecraft:snowman" -> new ItemStack(Items.AMMO_SNOWBALL);
+                            default -> null;
+                        };
                     if (itemstack == null) {
                         continue;
                     }
@@ -69,12 +69,12 @@ public class BlockLogicMobSpawner extends BlockLogicMobSpawnerDeactivated
                         if (itemstack.stackSize <= 0) {
                             continue label0;
                         }
-                        int i1 = world.rand.nextInt(21) + 10;
-                        if (i1 > itemstack.stackSize) {
-                            i1 = itemstack.stackSize;
+                        int qty = world.rand.nextInt(21) + 10;
+                        if (qty > itemstack.stackSize) {
+                            qty = itemstack.stackSize;
                         }
-                        itemstack.stackSize -= i1;
-                        EntityItem entityitem = new EntityItem(world, (float) tilePos.x + rx, (float) tilePos.y + ry, (float) tilePos.z + rz, new ItemStack(itemstack.itemID, i1, itemstack.getMetadata()));
+                        itemstack.stackSize -= qty;
+                        EntityItem entityitem = new EntityItem(world, (float) tilePos.x() + rx, (float) tilePos.y() + ry, (float) tilePos.z() + rz, new ItemStack(itemstack.itemID, qty, itemstack.getMetadata()));
                         float f3 = 0.05F;
                         entityitem.xd = (float) world.rand.nextGaussian() * f3;
                         entityitem.yd = (float) world.rand.nextGaussian() * f3 + 0.2F;
@@ -90,7 +90,7 @@ public class BlockLogicMobSpawner extends BlockLogicMobSpawnerDeactivated
     @Override
     public ItemStack[] getBreakResult(@NotNull World world, @NotNull EnumDropCause dropCause, int data, @Nullable TileEntity tileEntity) {
         if (dropCause == EnumDropCause.SILK_TOUCH) {
-            return new ItemStack[] { new ItemStack(Blocks.MOBSPAWNER_DEACTIVATED) };
+            return new ItemStack[]{new ItemStack(Blocks.MOBSPAWNER_DEACTIVATED)};
         }
         return null;
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMobSpawnerDeactivated.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMobSpawnerDeactivated.java
index 33cf2e9da..e2058485e 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMobSpawnerDeactivated.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMobSpawnerDeactivated.java
@@ -1,20 +1,20 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntity;
-import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 public class BlockLogicMobSpawnerDeactivated extends BlockLogicTransparent {
     public BlockLogicMobSpawnerDeactivated(@NotNull Block<?> block)
     {
-        super(block, Material.stone);
+        super(block, Materials.STONE);
     }
 
     @Override
@@ -30,7 +30,7 @@ public class BlockLogicMobSpawnerDeactivated extends BlockLogicTransparent {
     }
 
     @Override
-    public boolean collidesWithEntity(@NotNull Entity entity, @NotNull World world, @NotNull TilePos tilePos) {
+    public boolean collidesWithEntity(@NotNull Entity entity, @NotNull World world, @NotNull TilePosc tilePos) {
         return !(entity instanceof EntityItem);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMoss.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMoss.java
index 833505298..a78775613 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMoss.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMoss.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.block;
 
 import it.unimi.dsi.fastutil.ints.Int2IntArrayMap;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.item.IBonemealable;
@@ -8,8 +9,8 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
-import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -19,125 +20,132 @@ import java.util.Map.Entry;
 import java.util.Random;
 
 public class BlockLogicMoss extends BlockLogic implements IBonemealable {
-	public static Int2IntArrayMap variantMap = new Int2IntArrayMap();
-	public BlockLogicMoss(@NotNull Block<?> block, @NotNull Block<?> parentBlock) {
-		super(block, Material.moss);
-		block.setTicking(true);
-		variantMap.put(parentBlock.id(), block.id());
-	}
-
-	@Override
-	public void updateTick(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random rand, boolean isRandomTick) {
-		if (world.isClientSide) {
-			return;
-		}
-		
-		if (world.areBlocksLoaded(tilePos, 16)) {
-			if (rand.nextInt(20) == 0 && airExposed(world, tilePos)) {
-				Direction rDir = Direction.getDirectionById(rand.nextInt(6));
-				TilePos randomPos = tilePos.add(rDir);
-				if (canMossSpread(world, randomPos)) {
-					Block<?> mossStone = getMossBlock(world.getBlockId(randomPos));
-					if (mossStone != null) {
-						world.setBlockIdNotify(randomPos, mossStone.id());
-					}
-				}
-			}
-		}
-	}
-
-	
-	public boolean canMossSpread(@NotNull World world, @NotNull TilePos tilePos) {
-		if (!world.isBlockLoaded(tilePos)) return false;
-		int maxBlockLight = 0;
-		int maxSkyLight = 0;
-		for (int i = 0; i < Direction.directions.length; i++) {
-			Direction dir = Direction.directions[i];
-			TilePos offsetPos = tilePos.add(dir);
-			int blockLight = world.getBlockLightValue(offsetPos);
-			int skyLight = world.getSavedLightValue(LightLayer.Sky, offsetPos);
-			if (blockLight > maxBlockLight) { maxBlockLight = blockLight; }
-			if (skyLight > maxSkyLight) { maxSkyLight = skyLight; }
-		}
-		return maxBlockLight == 0 && maxSkyLight == 0;
-	}
-
-	public static @Nullable Block<?> getMossBlock(int blockId) {
-		return getMossBlock(Blocks.getBlock(blockId));
-	}
-
-	public static @Nullable Block<?> getMossBlock(@Nullable Block<?> stoneBlock) {
-		return stoneToMossMap.get(stoneBlock);
-	}
-	
-	public static @Nullable Block<?> getStoneBlock(final int blockId) {
-		return getStoneBlock(Blocks.getBlock(blockId));
-	}
-	
-	public static @Nullable Block<?> getStoneBlock(@Nullable Block<?> mossBlock) {
-		return mossToStoneMap.get(mossBlock);
-	}
-
-	public static final @NotNull Map<@NotNull Block<?>, @NotNull Block<?>> stoneToMossMap = new HashMap<>();
-	public static final @NotNull Map<@NotNull Block<?>, @NotNull Block<?>> mossToStoneMap = new HashMap<>();
-
-	public static void initMossMap() {
-		stoneToMossMap.clear();
-		mossToStoneMap.clear();
-
-		stoneToMossMap.put(Blocks.STONE, Blocks.MOSS_STONE);
-		stoneToMossMap.put(Blocks.GRANITE, Blocks.MOSS_GRANITE);
-		stoneToMossMap.put(Blocks.LIMESTONE, Blocks.MOSS_LIMESTONE);
-		stoneToMossMap.put(Blocks.BASALT, Blocks.MOSS_BASALT);
-		stoneToMossMap.put(Blocks.COBBLE_STONE, Blocks.COBBLE_STONE_MOSSY);
-		stoneToMossMap.put(Blocks.COBBLE_BASALT, Blocks.COBBLE_BASALT_MOSSY);
-		stoneToMossMap.put(Blocks.COBBLE_LIMESTONE, Blocks.COBBLE_LIMESTONE_MOSSY);
-		stoneToMossMap.put(Blocks.COBBLE_GRANITE, Blocks.COBBLE_GRANITE_MOSSY);
-		stoneToMossMap.put(Blocks.BRICK_STONE_POLISHED, Blocks.BRICK_STONE_POLISHED_MOSSY);
-		stoneToMossMap.put(Blocks.LOG_OAK, Blocks.LOG_OAK_MOSSY);
-		
-		for(Entry<Block<?>, Block<?>> entry : stoneToMossMap.entrySet()) {
-			mossToStoneMap.put(entry.getValue(), entry.getKey());
-		}
-	}
-
-	@Override
-	public boolean onBonemealUsed(@NotNull ItemStack itemStack, @Nullable Player player, @NotNull World world, @NotNull TilePos tilePos, @NotNull Side side, double xHit, double yHit) {
-		if(!world.isClientSide) {
-			if (!canMossSpread(world, tilePos) || !airExposed(world, tilePos)) return false;
-			if (player == null || player.getGamemode().consumeBlocks()) {
-				itemStack.stackSize--;
-			}
-			for(int i = 0; i < 32; i++) {
-				TilePos randomPos = new TilePos(tilePos);
-				for(int j = 0; j < i / 16; j++) {
-					randomPos.x += world.rand.nextInt(3) - 1;
-					randomPos.y += ((world.rand.nextInt(3) - 1) * world.rand.nextInt(3)) / 2;
-					randomPos.z += world.rand.nextInt(3) - 1;
-				}
-
-				if(!airExposed(world, randomPos)) {
-					continue;
-				}
-
-				if(!canMossSpread(world,randomPos)) {
-					continue;
-				}
-
-				Block<?> block = getMossBlock(world.getBlockId(randomPos));
-				if (block != null) {
-					world.setBlockIdNotify(randomPos, block.id());
-				}
-			}
-		}
-		return true;
-	}
-
-	public boolean airExposed(@NotNull World world, @NotNull TilePos tilePos) {
-		for (int i = 0; i < Direction.directions.length; i++) {
-			Direction dir = Direction.directions[i];
-			if (world.isAirBlock(tilePos.add(dir))) return true;
-		}
-		return false;
-	}
+    public static Int2IntArrayMap variantMap = new Int2IntArrayMap();
+
+    public BlockLogicMoss(@NotNull Block<?> block, @NotNull Block<?> parentBlock) {
+        super(block, Materials.MOSS);
+        block.setTicking(true);
+        variantMap.put(parentBlock.id(), block.id());
+    }
+
+    @Override
+    public void updateTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand, boolean isRandomTick) {
+        if (world.isClientSide) {
+            return;
+        }
+
+        if (world.areBlocksLoaded(tilePos, 16)) {
+            if (rand.nextInt(20) == 0 && airExposed(world, tilePos)) {
+                Direction rDir = Direction.getDirectionById(rand.nextInt(6));
+                TilePos randomPos = tilePos.add(rDir, new TilePos());
+                if (canMossSpread(world, randomPos)) {
+                    Block<?> mossStone = getMossBlock(world.getBlockId(randomPos));
+                    if (mossStone != null) {
+                        world.setBlockIdNotify(randomPos, mossStone.id());
+                    }
+                }
+            }
+        }
+    }
+
+
+    public boolean canMossSpread(@NotNull World world, @NotNull TilePosc tilePos) {
+        if (!world.isBlockLoaded(tilePos)) return false;
+        int maxBlockLight = 0;
+        int maxSkyLight = 0;
+        TilePos queryPos = new TilePos();
+        for (int i = 0; i < Direction.directions.length; i++) {
+            Direction dir = Direction.directions[i];
+            TilePos offsetPos = tilePos.add(dir, queryPos);
+            int blockLight = world.getBlockLightValue(offsetPos);
+            int skyLight = world.getSavedLightValue(LightLayer.Sky, offsetPos);
+            if (blockLight > maxBlockLight) {
+                maxBlockLight = blockLight;
+            }
+            if (skyLight > maxSkyLight) {
+                maxSkyLight = skyLight;
+            }
+        }
+        return maxBlockLight == 0 && maxSkyLight == 0;
+    }
+
+    public static @Nullable Block<?> getMossBlock(int blockId) {
+        return getMossBlock(Blocks.getBlock(blockId));
+    }
+
+    public static @Nullable Block<?> getMossBlock(@Nullable Block<?> stoneBlock) {
+        return stoneToMossMap.get(stoneBlock);
+    }
+
+    public static @Nullable Block<?> getStoneBlock(final int blockId) {
+        return getStoneBlock(Blocks.getBlock(blockId));
+    }
+
+    public static @Nullable Block<?> getStoneBlock(@Nullable Block<?> mossBlock) {
+        return mossToStoneMap.get(mossBlock);
+    }
+
+    public static final @NotNull Map<@NotNull Block<?>, @NotNull Block<?>> stoneToMossMap = new HashMap<>();
+    public static final @NotNull Map<@NotNull Block<?>, @NotNull Block<?>> mossToStoneMap = new HashMap<>();
+
+    public static void initMossMap() {
+        stoneToMossMap.clear();
+        mossToStoneMap.clear();
+
+        stoneToMossMap.put(Blocks.STONE, Blocks.MOSS_STONE);
+        stoneToMossMap.put(Blocks.GRANITE, Blocks.MOSS_GRANITE);
+        stoneToMossMap.put(Blocks.LIMESTONE, Blocks.MOSS_LIMESTONE);
+        stoneToMossMap.put(Blocks.BASALT, Blocks.MOSS_BASALT);
+        stoneToMossMap.put(Blocks.COBBLE_STONE, Blocks.COBBLE_STONE_MOSSY);
+        stoneToMossMap.put(Blocks.COBBLE_BASALT, Blocks.COBBLE_BASALT_MOSSY);
+        stoneToMossMap.put(Blocks.COBBLE_LIMESTONE, Blocks.COBBLE_LIMESTONE_MOSSY);
+        stoneToMossMap.put(Blocks.COBBLE_GRANITE, Blocks.COBBLE_GRANITE_MOSSY);
+        stoneToMossMap.put(Blocks.BRICK_STONE_POLISHED, Blocks.BRICK_STONE_POLISHED_MOSSY);
+        stoneToMossMap.put(Blocks.LOG_OAK, Blocks.LOG_OAK_MOSSY);
+
+        for (Entry<Block<?>, Block<?>> entry : stoneToMossMap.entrySet()) {
+            mossToStoneMap.put(entry.getValue(), entry.getKey());
+        }
+    }
+
+    @Override
+    public boolean onBonemealUsed(@NotNull ItemStack itemStack, @Nullable Player player, @NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
+        if (!world.isClientSide) {
+            if (!canMossSpread(world, tilePos) || !airExposed(world, tilePos)) return false;
+            if (player == null || player.getGamemode().consumeBlocks()) {
+                itemStack.stackSize--;
+            }
+            for (int i = 0; i < 32; i++) {
+                TilePos randomPos = new TilePos(tilePos);
+                for (int j = 0; j < i / 16; j++) {
+                    randomPos.x += world.rand.nextInt(3) - 1;
+                    randomPos.y += ((world.rand.nextInt(3) - 1) * world.rand.nextInt(3)) / 2;
+                    randomPos.z += world.rand.nextInt(3) - 1;
+                }
+
+                if (!airExposed(world, randomPos)) {
+                    continue;
+                }
+
+                if (!canMossSpread(world, randomPos)) {
+                    continue;
+                }
+
+                Block<?> block = getMossBlock(world.getBlockId(randomPos));
+                if (block != null) {
+                    world.setBlockIdNotify(randomPos, block.id());
+                }
+            }
+        }
+        return true;
+    }
+
+    public boolean airExposed(@NotNull World world, @NotNull TilePosc tilePos) {
+        TilePos queryPos = new TilePos();
+        for (int i = 0; i < Direction.directions.length; i++) {
+            Direction dir = Direction.directions[i];
+            if (world.isAirBlock(tilePos.add(dir, queryPos))) return true;
+        }
+        return false;
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMotionSensor.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMotionSensor.java
index 1c0ff74fc..baa904d8a 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMotionSensor.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMotionSensor.java
@@ -5,7 +5,7 @@ import java.util.Random;
 
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.entity.TileEntitySensor;
-import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Direction;
@@ -13,65 +13,63 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-public class BlockLogicMotionSensor extends BlockLogicVeryRotatable
-{
+public class BlockLogicMotionSensor extends BlockLogicVeryRotatable {
     public final boolean isActive;
 
-    public BlockLogicMotionSensor(@NotNull Block<?> block, boolean isActive)
-    {
-        super(block, Material.glass);
+    public BlockLogicMotionSensor(@NotNull Block<?> block, boolean isActive) {
+        super(block, Materials.GLASS);
         this.isActive = isActive;
         block.withEntity(TileEntitySensor::new);
     }
 
     @Override
-	public void animationTick(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random rand)
-    {
-        if(!this.isActive) {
+    public void animationTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand) {
+        if (!this.isActive) {
             return;
         }
 
+        TilePos queryPos = new TilePos();
         final int brightness = 10;
         double d = 0.0625;
         for (int i = 0; i < Direction.directions.length; i++) {
             Direction dir = Direction.directions[i];
-            double px = (double) tilePos.x + rand.nextFloat();
-            double py = (double) tilePos.y + rand.nextFloat();
-            double pz = (double) tilePos.z + rand.nextFloat();
+            double px = (double) tilePos.x() + rand.nextFloat();
+            double py = (double) tilePos.y() + rand.nextFloat();
+            double pz = (double) tilePos.z() + rand.nextFloat();
 
-            if (!world.isBlockOpaqueCube(tilePos.add(dir))) {
+            if (!world.isBlockOpaqueCube(tilePos.add(dir, queryPos))) {
                 switch (dir) {
-                    case UP -> py = (tilePos.y + 1) + d;
-                    case DOWN -> py = (tilePos.y) - d;
-                    case SOUTH -> pz = (tilePos.z + 1) + d;
-                    case NORTH -> pz = (tilePos.z) - d;
-                    case EAST -> px = (tilePos.x + 1) + d;
-                    case WEST -> px = (tilePos.x) - d;
+                    case UP -> py = (tilePos.y() + 1) + d;
+                    case DOWN -> py = (tilePos.y()) - d;
+                    case SOUTH -> pz = (tilePos.z() + 1) + d;
+                    case NORTH -> pz = (tilePos.z()) - d;
+                    case EAST -> px = (tilePos.x() + 1) + d;
+                    case WEST -> px = (tilePos.x()) - d;
                 }
             }
 
-            if (px < tilePos.x || px > (tilePos.x + 1) || py < 0.0D || py > (tilePos.y + 1) || pz < tilePos.z || pz > (tilePos.z + 1)) {
+            if (px < tilePos.x() || px > (tilePos.x() + 1) || py < 0.0D || py > (tilePos.y() + 1) || pz < tilePos.z() || pz > (tilePos.z() + 1)) {
                 world.spawnParticle("reddust", px, py, pz, 0, 0, 0, brightness);
             }
         }
     }
 
     @Override
-    public boolean isSignalSource()
-    {
+    public boolean isSignalSource() {
         return true;
     }
 
     @Override
-    public boolean isEmittingDirectSignal(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side) {
+    public boolean isEmittingDirectSignal(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
         return isEmittingSignal(world, tilePos, side);
     }
 
     @Override
-    public boolean isEmittingSignal(@NotNull WorldSource source, @NotNull TilePos tilePos, @NotNull Side side) {
+    public boolean isEmittingSignal(@NotNull WorldSource source, @NotNull TilePosc tilePos, @NotNull Side side) {
         return this.isActive;
     }
 
